/usr/bin/update-manager:aptdaemon.errors.AptDaemonError(org.debian.apt):_convert_dbus_exception:cancel:__call__:call_blocking:_on_clicked:_deferable:_convert_dbus_exception

Bug #1790670 reported by errors.ubuntu.com bug bridge on 2018-09-04
14
This bug affects 1 person
Affects Status Importance Assigned to Milestone
update-manager (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Unassigned
Bionic
Undecided
Unassigned

Bug Description

[Impact]

Closing the GUI of update-manager tries to cancel the running transaction then raises an Exception since cancellation fails.

Users experience crashes after closing the GUI and many of them send error reports about the issue while nothing can be done about those transactions.

The fix tries to close the transaction when it seems to be possible to cancel it and ignores the exception when cancellation fails.

[Test Case]

1. Set up a fully updated system then downgrade a few packages and install autoremovable ones to create work for u-m:
$ sudo eatmydata apt install -y --allow-downgrades linux-headers-4.15.0-32 linux-headers-4.15.0-32-generic gnome-software=3.28.1-0ubuntu4 gnome-software-common=3.28.1-0ubuntu4 ; sudo /etc/kernel/postinst.d/apt-auto-removal ; sudo apt-mark auto linux-headers-4.15.0-32 linux-headers-4.15.0-32-generic

2. Start update-manager from the terminal and press "Install Now".

3. While the transaction is running close u-m's GUI with the (X).
The fixed u-m GUI just closes, while the not fixed ones show exceptions. With the fix the GUI closes, but the transaction is run to completion in the background.

[Regression Potential]

There is not a lot of room for regressions. As usual update-manager may fail to start due to syntax errors, but ignoring the exception can hardly cause any trouble.
Users may find it surprising that the transaction proceeds in the background, but this is still better than trowing the exception like before.

[Other Info]

 * Anything else you think is useful to include
 * Anticipate questions from users, SRU, +1 maintenance, security teams and the Technical Board
 * and address these questions in advance

The Ubuntu Error Tracker has been receiving reports about a problem regarding update-manager. This problem was most recently seen with package version 1:18.10.4, the problem page at https://errors.ubuntu.com/problem/6d00ba06c8a67ead2e2021397da6006d84ddde5e contains more details, including versions of packages affected, stacktrace or traceback, and individual crash reports.
If you do not have access to the Ubuntu Error Tracker and are a software developer, you can request it at http://forms.canonical.com/reports/.

Related branches

Balint Reczey (rbalint) on 2018-10-03
description: updated
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:18.10.10

---------------
update-manager (1:18.10.10) cosmic; urgency=medium

  * Stop lazy import of InstallBackends.
    Lazy imports made update-manager crash when an update-manager
    update changed the backend API and an updated incompatible backend
    was loaded to the not updated running update-manager process. (LP: #1795898)
  * Cancel transaction on exit only when Cancel button is active.
    Also ignore exception when cancellation fails. (LP: #1790670)

 -- Balint Reczey <email address hidden> Thu, 04 Oct 2018 21:06:35 +0200

Changed in update-manager (Ubuntu):
status: New → Fix Released

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-manager into bionic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:18.04.11.6 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-bionic to verification-done-bionic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-bionic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in update-manager (Ubuntu Bionic):
status: New → Fix Committed
tags: added: verification-needed verification-needed-bionic
Balint Reczey (rbalint) wrote :

Tested with 1:18.04.11.6, the fix works as expected.

tags: added: verification-done verification-done-bionic
removed: verification-needed verification-needed-bionic

The verification of the Stable Release Update for update-manager has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:18.04.11.6

---------------
update-manager (1:18.04.11.6) bionic; urgency=medium

  * Keep or delete packages after looping over all of them.
    This prevents the resolver from changing the packages in the loop resulting
    in not keeping some phased packages back from being upgraded. (LP: #1072136)
  * Stop lazy import of InstallBackends.
    Lazy imports made update-manager crash when an update-manager
    update changed the backend API and an updated incompatible backend
    was loaded to the not updated running update-manager process. (LP: #1795898)
  * Cancel transaction on exit only when Cancel button is active.
    Also ignore exception when cancellation fails. (LP: #1790670)

 -- Balint Reczey <email address hidden> Thu, 04 Oct 2018 21:33:57 +0200

Changed in update-manager (Ubuntu Bionic):
status: Fix Committed → Fix Released

Hello errors.ubuntu.com, or anyone else affected,

Accepted update-manager into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/update-manager/1:16.04.15 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in update-manager (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed verification-needed-xenial
removed: verification-done
Balint Reczey (rbalint) wrote :

Verified with 1:16.04.15 on Xenial.

tags: added: verification-done verification-done-xenial
removed: verification-needed verification-needed-xenial
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:16.04.15

---------------
update-manager (1:16.04.15) xenial; urgency=medium

  * Keep or delete packages after looping over all of them.
    This prevents the resolver from changing the packages in the loop resulting
    in not keeping some phased packages back from being upgraded. (LP: #1072136)
  * Stop lazy import of InstallBackends.
    Lazy imports made update-manager crash when an update-manager
    update changed the backend API and an updated incompatible backend
    was loaded to the not updated running update-manager process. (LP: #1795898)
  * Cancel transaction on exit only when Cancel button is active.
    Also ignore exception when cancellation fails. (LP: #1790670)
  * Make commit()'s last parameter optional for avoiding crash on upgrade
    (LP: #1771894)

 -- Balint Reczey <email address hidden> Thu, 04 Oct 2018 21:51:10 +0200

Changed in update-manager (Ubuntu Xenial):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers